import javax.swing.*;
import java.awt.*;
import java.util.Observer;
import java.util.Observable;
/**
 * A graphical view of a Counter.
 * In this version, the constructor creates a JFrame in which to display
 * the counter, and attaches the Component as an observer of the counter.
 * 
 * @author Stephen Bloch
 * @version 8, Oct. 16
 */

public class CounterComponent extends JComponent implements Observer
{
    private String display = "";
    
    public CounterComponent (Counter toWatch, final String frameName)
    {
        javax.swing.SwingUtilities.invokeLater (new Runnable () {
            public void run () {
                JFrame frame = new JFrame (frameName);
                frame.setSize (200, 100);
                frame.add (CounterComponent.this);
                frame.setVisible (true);
            }
        });
        toWatch.addObserver (this);
    }
    
    public void paintComponent (Graphics g)
    {
        g.drawString (this.display, 100, 40);
    }
    
    public void update (Observable o, Object newValue)
    {
        this.display = newValue.toString(); // should be an Integer
        this.repaint ();
    }
}
